const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_transactions = sequelize.define(
    'inventory_transactions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

transaction_number: {
        type: DataTypes.TEXT,
      
      

      },

transaction_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"receipt",


"issue_to_production",


"production_return",


"transfer",


"adjustment",


"scrap",


"ship"

        ],

      },

transaction_at: {
        type: DataTypes.DATE,
      
      

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

reference: {
        type: DataTypes.TEXT,
      
      

      },

reason: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_transactions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.inventory_transactions.belongsTo(db.materials, {
      as: 'material',
      foreignKey: {
        name: 'materialId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.inventory_lots, {
      as: 'inventory_lot',
      foreignKey: {
        name: 'inventory_lotId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.storage_locations, {
      as: 'from_location',
      foreignKey: {
        name: 'from_locationId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.storage_locations, {
      as: 'to_location',
      foreignKey: {
        name: 'to_locationId',
      },
      constraints: false,
    });

    db.inventory_transactions.belongsTo(db.users, {
      as: 'performed_by',
      foreignKey: {
        name: 'performed_byId',
      },
      constraints: false,
    });



    db.inventory_transactions.hasMany(db.file, {
      as: 'attachments',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.inventory_transactions.getTableName(),
        belongsToColumn: 'attachments',
      },
    });


    db.inventory_transactions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_transactions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_transactions;
};


